var MongoClient = require('mongodb').MongoClient;
var assert = require('assert');
var express = require("express");

// -------------
// CODE MONGO DB
// -------------
var resultats = [];

var url = 'mongodb://localhost:27017/test';
var findRestaurants = function(db, n, pagesize, callback) {
    resultats = [];

    var cursor = db.collection('restaurants').find().skip(pagesize*(n-1)).limit(pagesize);
    var counter = 0;
    cursor.each(function(err, doc) {
       //assert.equal(err, null);
       // too many to output all of them
       if (counter++ === pagesize) {
           callback(resultats);
           console.log("Ok, that's enough!");
           //process.exit();
       }
       if(doc){
          console.dir(doc.name + " zip = " + doc.address.zipcode);
          resultats.push(doc);
       } else {
          callback(resultats);
       }
    });
 };
 
function getRestaurants(n, pagesize, callback) {
  MongoClient.connect(url, function(err, db) {
      assert.equal(null, err);
      findRestaurants(db, n, pagesize, function(resultats) {
          // Ici on est sur que les resultats
          // sont prÃªts
          callback(resultats);
          db.close();
      });
  });
}

// --------------------------
// CREATION SERVEUR + ROUTAGE
// --------------------------
var app = express();

app.use(express.static('public'));

app.get('/', function (req, res) {
   res.sendFile(__dirname + '/public/restaurants.html');
});

// Uniquement pour l'appel AJAX depuis le client
app.get('/findRestaurants', function (req, res) {
  var page = req.query.page;
  console.log("On recupere page = " + page);

  getRestaurants(page, 15, function(resultats) {
    res.end(JSON.stringify(resultats));
  });

  
});


app.listen(3000, function () {

  console.log("Server is listening on port 3000");
  console.log("Open http://localhost:3000 and upload some files!");

});